unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    N1: TMenuItem;
    procedure Open1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;



var
  Form1: TForm1;

implementation

uses
 EffectBass;

{$R *.DFM}


//------------------------------------------------------------------------------
// ֐    EffectMirror
// pr      摜]
// 
//             hBMP            ...Hrbg}bṽnh
// ߂l@@rbg}bṽnh
// -----------------------------------------------------------------------------
function EffectMirror(hBMP :HBitmap):HBitmap;
var
 Row,Col        : integer;
 SrcRow,DestRow : pRGBArray;
 SrcBitmap,DestBitmap     : TBitmap;
begin
 SrcBitmap   :=TBitmap.Create;
 DestBitmap  :=TBitmap.Create;
 SrcBitmap.Handle  :=hBMP;
 Set24bit(SrcBitmap,DestBitmap);

 Try
  for Row:=DestBitmap.Height-1 Downto 0 do
  begin
   SrcRow:=SrcBitmap.ScanLine[Row];
   DestRow:=DestBitmap.ScanLine[Row];

   for Col:=0 to DestBitmap.Width-1 do
   begin
     DestRow[Col].rgbtRed  :=SrcRow[SrcBitmap.Width-Col-1].rgbtRed;
     DestRow[Col].rgbtGreen:=SrcRow[SrcBitmap.Width-Col-1].rgbtGreen;
     DestRow[Col].rgbtBlue :=SrcRow[SrcBitmap.Width-Col-1].rgbtBlue;
   end;
  end;
 Result := DestBitmap.ReleaseHandle;
except
 Result := SrcBitmap.ReleaseHandle;
end;
 SrcBitmap.Free;
 DestBitmap.Free;
end;

//-----------------------------------------------------------------------------
// ֐    EffectFlip
// pr      摜]
// 
//             hBMP             ...Hrbg}bṽnh
// ߂l@@rbg}bṽnh
// -----------------------------------------------------------------------------
function EffectFlip(hBMP :HBitmap):HBitmap;
var
  Row,Col            : Integer;
  SrcRow,DestRow     : pRGBArray;
  SrcBitmap,DestBitmap  : TBitmap;
begin
  SrcBitmap   :=TBitmap.Create;
  DestBitmap  :=TBitmap.Create;
  SrcBitmap.Handle :=hBMP;
  Set24bit(SrcBitmap,DestBitmap);
try
  for Row:=DestBitmap.Height-1 Downto 0 do
  begin
   SrcRow:=SrcBitmap.ScanLine[DestBitmap.Height-Row-1];
   DestRow:=DestBitmap.ScanLine[Row];

   for Col:=0 to DestBitmap.Width-1 do
   begin
     DestRow[Col].rgbtBlue :=SrcRow[Col].rgbtBlue;
     DestRow[Col].rgbtGreen:=SrcRow[Col].rgbtGreen;
     DestRow[Col].rgbtRed  :=SrcRow[Col].rgbtRed;
   end;
  end;

  Result := DestBitmap.ReleaseHandle;
except
 Result := SrcBitmap.ReleaseHandle;
end;
 SrcBitmap.Free;
 DestBitmap.Free;
end;

//------------------------------------------------------------------------------
//֐@ EffectTrunpEX
//pr     gv]
//     hBMP             ...]TBitmap̃nh
//߂l @rbg}bṽnh
//------------------------------------------------------------------------------
function EffectTrunpEX(hBMP :HBitmap):HBitmap;
var
 divs       : Integer;
 SrcBitmap,DestBitmap,Mirror : TBitmap;
begin

  SrcBitmap   :=TBitmap.Create;
  DestBitmap  :=TBitmap.Create;
  Mirror      :=TBitmap.Create;
  SrcBitmap.handle :=hBMP;
  SrcBitmap.PixelFormat:=pf24bit;
  DestBitmap.PixelFormat:=pf24bit;
  DestBitmap.Assign(SrcBitmap);
  Mirror.Assign(SrcBitmap);
  Mirror.Handle:=EffectMirror(Mirror.ReleaseHandle) ;
  Mirror.Handle:=EffectFlip(Mirror.ReleaseHandle) ;

  if (DestBitmap.Width mod 2) =0  then
     divs:=DestBitmap.Width div 2
  else
     divs:=(DestBitmap.Width div 2)+1;

  BitBlt(DestBitmap.canvas.handle,divs,0,DestBitmap.Width,DestBitmap.Height,
         Mirror.canvas.Handle,divs,0,SRCCOPY);
  Result :=DestBitmap.ReleaseHandle;
  SrcBitmap.Free  ;
  DestBitmap.Free;
  Mirror.Free;
end;



/////////
procedure TForm1.Open1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
 begin
   Image1.Picture.bitmap.LoadFromFIle(OpenDialog1.FIlename);
   N1.Enabled :=true;
 end;
end;

/////////
procedure TForm1.N1Click(Sender: TObject);
begin
 //Run
 Image1.Picture.bitmap.Handle:= EffectTrunpEx(Image1.Picture.Bitmap.ReleaseHandle);
end;

end.
